; Disassembly of icehocky.bin
; Disassembled Fri Mar 25 18:06:37 2005
; Using DiStella v2.0
;
; Command Line:       C:\BIN\DISTELLA.EXE -pafscicehocky.cfg icehocky.bin 
;
; icehocky.cfg contents:
;
;      CODE F000 F1A2
;      GFX F1A3 F1FF
;      CODE F200 FE2C
;      GFX FE2D FFFF
;      

      processor 6502

;hardware register equates
VSYNC   =  $00 ;Vertical Sync Set-Clear
VBLANK  =  $01 ;Vertical Blank Set-Clear
WSYNC   =  $02 ;Wait for Horizontal Blank
RSYNC   =  $03 ;Reset Horizontal Sync Counter
NUSIZ0  =  $04 ;Number-Size player/missle 0
NUSIZ1  =  $05 ;Number-Size player/missle 1
COLUP0  =  $06 ;Color-Luminance Player 0
COLUP1  =  $07 ;Color-Luminance Player 1
COLUPF  =  $08 ;Color-Luminance Playfield
COLUBK  =  $09 ;Color-Luminance Background
CTRLPF  =  $0A ;Control Playfield, Ball, Collisions
REFP0   =  $0B ;Reflection Player 0
REFP1   =  $0C ;Reflection Player 1
PF0     =  $0D ;Playfield Register Byte 0 (upper nybble used only)
PF1     =  $0E ;Playfield Register Byte 1
PF2     =  $0F ;Playfield Register Byte 2
RESP0   =  $10 ;Reset Player 0
RESP1   =  $11 ;Reset Player 1
RESM0   =  $12 ;Reset Missle 0
RESM1   =  $13 ;Reset Missle 1
RESBL   =  $14 ;Reset Ball
;Audio registers
AUDC0   =  $15 ;Audio Control - Voice 0 (distortion)
AUDC1   =  $16 ;Audio Control - Voice 1 (distortion)
AUDF0   =  $17 ;Audio Frequency - Voice 0
AUDF1   =  $18 ;Audio Frequency - Voice 1
AUDV0   =  $19 ;Audio Volume - Voice 0
AUDV1   =  $1A ;Audio Volume - Voice 1
;Sprite registers
GRP0    =  $1B ;Graphics Register Player 0
GRP1    =  $1C ;Graphics Register Player 1
ENAM0   =  $1D ;Graphics Enable Missle 0
ENAM1   =  $1E ;Graphics Enable Missle 1
ENABL   =  $1F ;Graphics Enable Ball
HMP0    =  $20 ;Horizontal Motion Player 0
HMP1    =  $21 ;Horizontal Motion Player 1
HMM0    =  $22 ;Horizontal Motion Missle 0
HMM1    =  $23 ;Horizontal Motion Missle 1
HMBL    =  $24 ;Horizontal Motion Ball
VDELP0  =  $25 ;Vertical Delay Player 0
VDELP1  =  $26 ;Vertical Delay Player 1
VDEL01  =  $26 ;Vertical Delay Player 1
VDELBL  =  $27 ;Vertical Delay Ball
RESMP0  =  $28 ;Reset Missle 0 to Player 0
RESMP1  =  $29 ;Reset Missle 1 to Player 1
HMOVE   =  $2A ;Apply Horizontal Motion
HMCLR   =  $2B ;Clear Horizontal Move Registers
CXCLR   =  $2C ;Clear Collision Latches
Waste1  =  $2D ;Unused
Waste2  =  $2E ;Unused
Waste3  =  $2F ;Unused
;collisions                     (bit 7) (bit 6)
CXM0P   =  $30 ;Read Collision - M0-P1   M0-P0
CXM1P   =  $31 ;Read Collision - M1-P0   M1-P1
CXP0FB  =  $32 ;Read Collision - P0-PF   P0-BL
CXP1FB  =  $33 ;Read Collision - P1-PF   P1-BL
CXM0FB  =  $34 ;Read Collision - M0-PF   M0-BL
CXM1FB  =  $35 ;Read Collision - M1-PF   M1-BL
CXBLPF  =  $36 ;Read Collision - BL-PF   -----
CXPPMM  =  $37 ;Read Collision - P0-P1   M0-M1
INPT0   =  $38 ;Read Pot Port 0
INPT1   =  $39 ;Read Pot Port 1
INPT2   =  $3A ;Read Pot Port 2
INPT3   =  $3B ;Read Pot Port 3
INPT4   =  $3C ;Read Input - Trigger 0 (bit 7)
INPT5   =  $3D ;Read Input - Trigger 1 (bit 7)
;RIOT registers
SWCHA  = $0280 ;Port A data register for joysticks (High nybble:player0,low nybble:player1)
SWACNT = $0281 ;Port A data direction register (DDR)
SWCHB  = $0282 ;Port B data (console switches) bit pattern LR--B-SR
SWBCNT = $0283 ;Port B data direction register (DDR)
INTIM  = $0284 ;Timer output
TIMINT = $0285 ;
WasteA = $0286 ;Unused/undefined
WasteB = $0287 ;Unused/undefined
WasteC = $0288 ;Unused/undefined
WasteD = $0289 ;Unused/undefined
WasteE = $028A ;Unused/undefined
WasteF = $028B ;Unused/undefined
WasteG = $028C ;Unused/undefined
WasteH = $028D ;Unused/undefined
WasteI = $028E ;Unused/undefined
WasteJ = $028F ;Unused/undefined
WasteK = $0290 ;Unused/undefined
WasteL = $0291 ;Unused/undefined
WasteM = $0292 ;Unused/undefined
WasteN = $0293 ;Unused/undefined
TIM1T  = $0294 ;set 1 clock interval
TIM8T  = $0295 ;set 8 clock interval
TIM64T = $0296 ;set 64 clock interval
T1024T = $0297 ;set 1024 clock interval


       ORG $F000

START:
       SEI                            ;2
       CLD                            ;2
       LDX    #$FF                    ;2
       TXS                            ;2
       INX                            ;2
       JSR    LFD43                   ;6
       LDA    #$AA                    ;2
       STA    $87                     ;3
       STA    $86                     ;3
       STA    $8A                     ;3
       LDA    #$A4                    ;2
       STA    $F8                     ;3
       LDA    #$01                    ;2
       STA    $8B                     ;3
       LDA    #$11                    ;2
       STA    CTRLPF                  ;3
LF01D:
       LDX    #$04                    ;2
       LDA    $B4                     ;3
       JSR    LFCBC                   ;6
       LDX    #$03                    ;2
LF026:
       LDA    SWCHB                   ;4
       AND    #$08                    ;2
       STA    $F7                     ;3
       BNE    LF034                   ;2
       LDA    LFE43,X                 ;4
       BNE    LF037                   ;2
LF034:
       LDA    LFE3F,X                 ;4
LF037:
       EOR    $F9                     ;3
       AND    $83                     ;3
       STA    $EF,X                   ;4
       DEX                            ;2
       BPL    LF026                   ;2
       STX    PF0                     ;3
       LDX    $F0                     ;3
       STX    COLUPF                  ;3
       STA    COLUBK                  ;3
       LDA    $86                     ;3
       AND    #$0F                    ;2
       TAX                            ;2
LF04D:
       LDA    INTIM                   ;4
       BNE    LF04D                   ;2
       STA    WSYNC                   ;3
       STA    HMOVE                   ;3
       STA    VBLANK                  ;3
       LDA    LF1CD,X                 ;4
       STA    $D0                     ;3
       LDA    $86                     ;3
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       TAX                            ;2
       LDA    LF1CD,X                 ;4
       STA    $CE                     ;3
       LDA    $F8                     ;3
       STA    $CC                     ;3
       LDA    $87                     ;3
       AND    #$0F                    ;2
       TAX                            ;2
       LDA    LF1CD,X                 ;4
       STA    $CA                     ;3
       JSR    LFD07                   ;6
       LDA    $8B                     ;3
       AND    #$0F                    ;2
       TAX                            ;2
       LDA    LF1CD,X                 ;4
       STA    $D0                     ;3
       LDA    $8B                     ;3
       STA    RESP1                   ;3
       STA    RESP0                   ;3
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       BNE    LF092                   ;2
       LDA    #$0A                    ;2
LF092:
       TAX                            ;2
       LDA    LF1CD,X                 ;4
       STA    $CE                     ;3
       LDA    $8A                     ;3
       AND    #$0F                    ;2
       TAX                            ;2
       LDA    LF1CD,X                 ;4
       STA    $CC                     ;3
       LDA    $8A                     ;3
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       BNE    LF0AC                   ;2
       LDA    #$0A                    ;2
LF0AC:
       TAX                            ;2
       LDA    LF1CD,X                 ;4
       STA    $CA                     ;3
       STA    HMCLR                   ;3
       LDX    #$04                    ;2
       JSR    LFD03                   ;6
       LDA    $B9                     ;3
       JSR    LFCBC                   ;6
       LDA    $D2                     ;3
       STA    HMM0                    ;3
       LDA    $D3                     ;3
       STA    HMM1                    ;3
       LDA    $BD                     ;3
       STA    REFP0                   ;3
       LDX    #$01                    ;2
       STX    VDELP0                  ;3
       LDA    $BA                     ;3
       JSR    LFCBC                   ;6
       LDA    $BE                     ;3
       STA    REFP1                   ;3
       STA    WSYNC                   ;3
       STA    HMOVE                   ;3
       LDA    $D2                     ;3
       STA    ENAM0                   ;3
       LDA    $D3                     ;3
       STA    ENAM1                   ;3
       LDX    #$36                    ;2
       LDY    #$00                    ;2
       STY    NUSIZ0                  ;3
       STY    NUSIZ1                  ;3
       STY    HMP0                    ;3
       STY    HMP1                    ;3
       DEY                            ;2
       STY    RESMP0                  ;3
       STY    RESMP1                  ;3
       LDA    $F7                     ;3
       BEQ    LF0FA                   ;2
       LDX    #$22                    ;2
LF0FA:
       STX    $CA                     ;3
       INX                            ;2
       LDA    $8C                     ;3
       BPL    LF105                   ;2
       LDX    #$36                    ;2
       STX    $CA                     ;3
LF105:
       STX    $CC                     ;3
       LDX    #$A2                    ;2
       BNE    LF132                   ;2
LF10B:
       STY    $88,X                   ;4
LF10D:
       LDA    #$00                    ;2
       STA    $011C                   ;4
       BEQ    LF145                   ;2
LF114:
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       JMP    LF152                   ;3
LF11A:
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       STA    HMOVE                   ;3
       NOP                            ;2
       NOP                            ;2
       LDA    #$00                    ;2
       STA    GRP1                    ;3
       BEQ    LF16D                   ;2
LF129:
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       LDA    VSYNC                   ;3
       LDA    #$FF                    ;2
       BNE    LF17C                   ;2
LF132:
       STA    WSYNC                   ;3
       STA    COLUP0                  ;3
       STY    ENABL                   ;3
       DEX                            ;2
       TXA                            ;2
       SBC    $B6                     ;3
       CMP    #$14                    ;2
       BCS    LF10D                   ;2
       TAY                            ;2
       LDA    ($C4),Y                 ;5
       STA    GRP1                    ;3
LF145:
       TXA                            ;2
       SEC                            ;2
       SBC    $B5                     ;3
       CMP    #$14                    ;2
       BCS    LF114                   ;2
       TAY                            ;2
       LDA    ($C2),Y                 ;5
       STA    GRP0                    ;3
LF152:
       LDY    #$00                    ;2
       STY    NUSIZ0                  ;3
       DEX                            ;2
       TXA                            ;2
       SEC                            ;2
       SBC    $B6                     ;3
       CMP    #$14                    ;2
       BCS    LF11A                   ;2
       TAY                            ;2
       LDA    ($C4),Y                 ;5
       STA    GRP1                    ;3
       NOP                            ;2
       STA    HMOVE                   ;3
       LDA    ($CC),Y                 ;5
       STA    COLUP1                  ;3
       STA    RESMP1                  ;3
LF16D:
       TXA                            ;2
       SEC                            ;2
       SBC    $B5                     ;3
       CMP    #$14                    ;2
       BCS    LF129                   ;2
       TAY                            ;2
       LDA    ($C2),Y                 ;5
       STA    GRP0                    ;3
       LDA    ($CA),Y                 ;5
LF17C:
       LDY    #$01                    ;2
       CPX    $DB                     ;3
       BNE    LF183                   ;2
       INY                            ;2
LF183:
       CPX    #$92                    ;2
       BNE    LF193                   ;2
       TXS                            ;2
       LDX    #$F0                    ;2
       STX    PF2                     ;3
       STX    PF1                     ;3
       TSX                            ;2
       STA    RESMP0                  ;3
       BNE    LF132                   ;2
LF193:
       CPX    #$8F                    ;2
       STA    RESMP0                  ;3
       BCS    LF132                   ;2
       SEC                            ;2
       STA    COLUP0                  ;3
       LDA    #$00                    ;2
       STA    PF2                     ;3
       JMP    LF248                   ;3
LF1A3:
       .byte $FE ; |XXXXXXX | $F1A3
       .byte $FF ; |XXXXXXXX| $F1A4
       .byte $00 ; |        | $F1A5
       .byte $01 ; |       X| $F1A6
       .byte $C1 ; |XX     X| $F1A7
       .byte $87 ; |X    XXX| $F1A8
       .byte $C5 ; |XX   X X| $F1A9
       .byte $4D ; | X  XX X| $F1AA
       .byte $6D ; | XX XX X| $F1AB
       .byte $79 ; | XXXX  X| $F1AC
       .byte $39 ; |  XXX  X| $F1AD
       .byte $31 ; |  XX   X| $F1AE
       .byte $03 ; |      XX| $F1AF
       .byte $36 ; |  XX XX | $F1B0
       .byte $36 ; |  XX XX | $F1B1
       .byte $3C ; |  XXXX  | $F1B2
       .byte $3C ; |  XXXX  | $F1B3
       .byte $38 ; |  XXX   | $F1B4
       .byte $30 ; |  XX    | $F1B5
       .byte $00 ; |        | $F1B6
       .byte $30 ; |  XX    | $F1B7
       .byte $30 ; |  XX    | $F1B8
       .byte $30 ; |  XX    | $F1B9
       .byte $C0 ; |XX      | $F1BA
       .byte $86 ; |X    XX | $F1BB
       .byte $D4 ; |XX X X  | $F1BC
       .byte $6C ; | XX XX  | $F1BD
       .byte $7C ; | XXXXX  | $F1BE
       .byte $78 ; | XXXX   | $F1BF
       .byte $38 ; |  XXX   | $F1C0
       .byte $38 ; |  XXX   | $F1C1
       .byte $04 ; |     X  | $F1C2
       .byte $34 ; |  XX X  | $F1C3
       .byte $38 ; |  XXX   | $F1C4
       .byte $38 ; |  XXX   | $F1C5
       .byte $38 ; |  XXX   | $F1C6
       .byte $38 ; |  XXX   | $F1C7
       .byte $30 ; |  XX    | $F1C8
       .byte $00 ; |        | $F1C9
       .byte $30 ; |  XX    | $F1CA
       .byte $30 ; |  XX    | $F1CB
       .byte $30 ; |  XX    | $F1CC
LF1CD:
       .byte $5E ; | X XXXX | $F1CD
       .byte $65 ; | XX  X X| $F1CE
       .byte $6C ; | XX XX  | $F1CF
       .byte $73 ; | XXX  XX| $F1D0
       .byte $7A ; | XXXX X | $F1D1
       .byte $81 ; |X      X| $F1D2
       .byte $88 ; |X   X   | $F1D3
       .byte $8F ; |X   XXXX| $F1D4
       .byte $96 ; |X  X XX | $F1D5
       .byte $9D ; |X  XXX X| $F1D6
LF1D7:
       .byte $A4 ; |X X  X  | $F1D7
       .byte $02 ; |      X | $F1D8
       .byte $01 ; |       X| $F1D9
       .byte $08 ; |    X   | $F1DA
       .byte $08 ; |    X   | $F1DB
       .byte $08 ; |    X   | $F1DC
       .byte $30 ; |  XX    | $F1DD
       .byte $30 ; |  XX    | $F1DE
LF1DF:
       .byte $30 ; |  XX    | $F1DF
       .byte $08 ; |    X   | $F1E0
       .byte $1F ; |   XXXXX| $F1E1
       .byte $1F ; |   XXXXX| $F1E2
       .byte $04 ; |     X  | $F1E3
       .byte $1F ; |   XXXXX| $F1E4
       .byte $08 ; |    X   | $F1E5
       .byte $0C ; |    XX  | $F1E6
LF1E7:
       .byte $1F ; |   XXXXX| $F1E7
       .byte $04 ; |     X  | $F1E8
       .byte $04 ; |     X  | $F1E9
       .byte $02 ; |      X | $F1EA
       .byte $08 ; |    X   | $F1EB
       .byte $01 ; |       X| $F1EC
       .byte $0C ; |    XX  | $F1ED
       .byte $0C ; |    XX  | $F1EE
       .byte $0C ; |    XX  | $F1EF
LF1F0:
       .byte $8B ; |X   X XX| $F1F0
       .byte $8B ; |X   X XX| $F1F1
       .byte $5B ; | X XX XX| $F1F2
       .byte $5B ; | X XX XX| $F1F3
LF1F4:
       .byte $37 ; |  XX XXX| $F1F4
       .byte $37 ; |  XX XXX| $F1F5
       .byte $09 ; |    X  X| $F1F6
       .byte $09 ; |    X  X| $F1F7
LF1F8:
       .byte $00 ; |        | $F1F8
       .byte $20 ; |  X     | $F1F9
       .byte $40 ; | X      | $F1FA
       .byte $60 ; | XX     | $F1FB
       .byte $80 ; |X       | $F1FC
       .byte $A0 ; |X X     | $F1FD
       .byte $C0 ; |XX      | $F1FE
       .byte $E0 ; |XXX     | $F1FF
LF200:
       STA    GRP1                    ;3
       LDA    VSYNC                   ;3
       NOP                            ;2
       LDA    $D7                     ;3
       STA    HMM1                    ;3
       BNE    LF25B                   ;2
LF20B:
       LDA    #$00                    ;2
       STA    GRP1                    ;3
       LDA    #$FF                    ;2
       STA    RESMP1                  ;3
       BNE    LF25B                   ;2
LF215:
       STA    $011B                   ;4
       LDA    $D6                     ;3
       STA    HMM0                    ;3
       LDY    #$20                    ;2
       BNE    LF26C                   ;2
LF220:
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       BCS    LF26A                   ;2
LF225:
       LDY    #$00                    ;2
       STA    HMOVE                   ;3
       STY    GRP1                    ;3
       LDY    #$20                    ;2
       CMP    #$FF                    ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       BNE    LF239                   ;2
       STY    NUSIZ1                  ;3
       BEQ    LF287                   ;2
LF239:
       NOP                            ;2
       BNE    LF287                   ;2
LF23C:
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       LDA    #$02                    ;2
       BNE    LF298                   ;2
LF246:
       STA    WSYNC                   ;3
LF248:
       STY    ENABL                   ;3
       DEX                            ;2
       TXA                            ;2
       SBC    $B6                     ;3
       BEQ    LF200                   ;2
       CMP    #$14                    ;2
       BCS    LF20B                   ;2
       TAY                            ;2
       LDA    ($C4),Y                 ;5
       STA    GRP1                    ;3
       NOP                            ;2
       NOP                            ;2
LF25B:
       TXA                            ;2
       SEC                            ;2
       SBC    $B5                     ;3
       BEQ    LF215                   ;2
       CMP    #$14                    ;2
       BCS    LF220                   ;2
       TAY                            ;2
       LDA    ($C2),Y                 ;5
       STA    GRP0                    ;3
LF26A:
       LDY    #$00                    ;2
LF26C:
       DEX                            ;2
       TXA                            ;2
       SEC                            ;2
       SBC    $B6                     ;3
       CMP    #$14                    ;2
       STY    NUSIZ0                  ;3
       BCS    LF225                   ;2
       NOP                            ;2
       TAY                            ;2
       STA    HMOVE                   ;3
       LDA    ($C4),Y                 ;5
       STA    GRP1                    ;3
       LDA    ($CC),Y                 ;5
       EOR    $82                     ;3
       STA    COLUP1                  ;3
       STA    RESMP1                  ;3
LF287:
       TXA                            ;2
       SEC                            ;2
       SBC    $B5                     ;3
       CMP    #$14                    ;2
       BCS    LF23C                   ;2
       TAY                            ;2
       LDA    ($C2),Y                 ;5
       STA    GRP0                    ;3
       LDA    ($CA),Y                 ;5
       EOR    $82                     ;3
LF298:
       LDY    #$01                    ;2
       CPX    $DB                     ;3
       STA    COLUP0                  ;3
       BNE    LF2A6                   ;2
       INY                            ;2
       NOP                            ;2
       STA    RESMP0                  ;3
       BNE    LF246                   ;2
LF2A6:
       CPX    $DE                     ;3
       STA    RESMP0                  ;3
       BCS    LF246                   ;2
       STA    WSYNC                   ;3
       STY    ENABL                   ;3
       LDA    $91                     ;3
       STA    GRP1                    ;3
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       LDA    $E9                     ;3
       STA    HMM1                    ;3
       LDA    $E8                     ;3
       STA    RESMP1                  ;3
       LDY    $E6                     ;3
LF2C1:
       DEY                            ;2
       BPL    LF2C1                   ;2
       STA    RESP0                   ;3
       LDA    $E4                     ;3
       STA    HMP0                    ;3
       DEX                            ;2
       STA    WSYNC                   ;3
       STA    HMOVE                   ;3
       LDA    $92                     ;3
       STA    GRP1                    ;3
       LDA    $93                     ;3
       STA    COLUP1                  ;3
       LDA    $94                     ;3
       STA    NUSIZ1                  ;3
       LDA    $EA                     ;3
       STA    RESMP1                  ;3
       DEX                            ;2
       LDY    #$01                    ;2
       CPX    $DB                     ;3
       BNE    LF2E7                   ;2
       INY                            ;2
LF2E7:
       LDA    #$00                    ;2
       STA    HMP0                    ;3
       LDA    $BF                     ;3
       STA    REFP0                   ;3
       SEC                            ;2
       LDA    $D4                     ;3
       STA    HMM0                    ;3
       STA    ENAM0                   ;3
       LDA    #$FF                    ;2
       STA    RESMP0                  ;3
       LDA    #$00                    ;2
       STA    NUSIZ0                  ;3
       JMP    LF347                   ;3
LF301:
       STA    GRP1                    ;3
       LDA    VSYNC                   ;3
       NOP                            ;2
       LDA    $D7                     ;3
       STA    HMM1                    ;3
       BNE    LF35C                   ;2
LF30C:
       LDA    #$00                    ;2
       STA    GRP1                    ;3
       LDA    #$FF                    ;2
       STA    RESMP1                  ;3
       BNE    LF35C                   ;2
LF316:
       STA    $011B                   ;4
       LDA    $D8                     ;3
       STA    HMM0                    ;3
       LDY    #$20                    ;2
       BNE    LF36D                   ;2
LF321:
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       BCS    LF36B                   ;2
LF326:
       LDY    #$00                    ;2
       STA    HMOVE                   ;3
       STY    GRP1                    ;3
       LDY    #$20                    ;2
       CMP    #$FF                    ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       BNE    LF33A                   ;2
       STY    NUSIZ1                  ;3
       BEQ    LF388                   ;2
LF33A:
       NOP                            ;2
       BNE    LF388                   ;2
LF33D:
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       LDA    #$02                    ;2
       BNE    LF399                   ;2
LF347:
       STA    WSYNC                   ;3
       STY    ENABL                   ;3
       DEX                            ;2
       TXA                            ;2
       SBC    $B6                     ;3
       BEQ    LF301                   ;2
       CMP    #$14                    ;2
       BCS    LF30C                   ;2
       TAY                            ;2
       LDA    ($C4),Y                 ;5
       STA    GRP1                    ;3
       NOP                            ;2
       NOP                            ;2
LF35C:
       TXA                            ;2
       SEC                            ;2
       SBC    $B7                     ;3
       BEQ    LF316                   ;2
       CMP    #$14                    ;2
       BCS    LF321                   ;2
       TAY                            ;2
       LDA    ($C6),Y                 ;5
       STA    GRP0                    ;3
LF36B:
       LDY    #$00                    ;2
LF36D:
       DEX                            ;2
       TXA                            ;2
       SEC                            ;2
       SBC    $B6                     ;3
       CMP    #$14                    ;2
       STY    NUSIZ0                  ;3
       BCS    LF326                   ;2
       NOP                            ;2
       TAY                            ;2
       STA    HMOVE                   ;3
       LDA    ($C4),Y                 ;5
       STA    GRP1                    ;3
       LDA    ($CC),Y                 ;5
       EOR    $82                     ;3
       STA    COLUP1                  ;3
       STA    RESMP1                  ;3
LF388:
       TXA                            ;2
       SEC                            ;2
       SBC    $B7                     ;3
       CMP    #$14                    ;2
       BCS    LF33D                   ;2
       TAY                            ;2
       LDA    ($C6),Y                 ;5
       STA    GRP0                    ;3
       LDA    ($CA),Y                 ;5
       EOR    $82                     ;3
LF399:
       LDY    #$01                    ;2
       CPX    $DB                     ;3
       STA    COLUP0                  ;3
       BNE    LF3A7                   ;2
       INY                            ;2
       NOP                            ;2
       STA    RESMP0                  ;3
       BNE    LF347                   ;2
LF3A7:
       CPX    $DF                     ;3
       STA    RESMP0                  ;3
       BCS    LF347                   ;2
       STA    WSYNC                   ;3
       LDA    #$00                    ;2
       STA    GRP1                    ;3
       STY    ENABL                   ;3
       LDA    $95                     ;3
       STA    GRP0                    ;3
       LDA    $97                     ;3
       STA    HMM0                    ;3
       LDA    $80                     ;3
       NOP                            ;2
       NOP                            ;2
       LDY    $E7                     ;3
LF3C3:
       DEY                            ;2
       BPL    LF3C3                   ;2
       STA    RESP1                   ;3
       LDA    $E5                     ;3
       STA    HMP1                    ;3
       DEX                            ;2
       LDA    VSYNC                   ;3
       LDY    $96                     ;3
       STA    WSYNC                   ;3
       STA    HMOVE                   ;3
       LDA    VSYNC                   ;3
       STY    NUSIZ0                  ;3
       LDA    #$00                    ;2
       STA    GRP1                    ;3
       LDA    $98                     ;3
       STA    GRP0                    ;3
       DEX                            ;2
       LDY    #$01                    ;2
       CPX    $DB                     ;3
       BNE    LF3E9                   ;2
       INY                            ;2
LF3E9:
       LDA    #$00                    ;2
       STA    HMP1                    ;3
       SEC                            ;2
       LDA    $D5                     ;3
       STA    HMM1                    ;3
       STA    ENAM1                   ;3
       LDA    #$00                    ;2
       STA    NUSIZ1                  ;3
       LDA    $C0                     ;3
       STA    REFP1                   ;3
       LDA    $99                     ;3
       STA    COLUP0                  ;3
       LDA    $EB                     ;3
       STA    RESMP0                  ;3
       JMP    LF44D                   ;3
LF407:
       STA    GRP1                    ;3
       LDA    VSYNC                   ;3
       NOP                            ;2
       LDA    $D9                     ;3
       STA    HMM1                    ;3
       BNE    LF462                   ;2
LF412:
       LDA    #$00                    ;2
       STA    GRP1                    ;3
       LDA    #$FF                    ;2
       STA    RESMP1                  ;3
       BNE    LF462                   ;2
LF41C:
       STA    $011B                   ;4
       LDA    $D8                     ;3
       STA    HMM0                    ;3
       LDY    #$20                    ;2
       BNE    LF473                   ;2
LF427:
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       BCS    LF471                   ;2
LF42C:
       LDY    #$00                    ;2
       STA    HMOVE                   ;3
       STY    GRP1                    ;3
       LDY    #$20                    ;2
       CMP    #$FF                    ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       BNE    LF440                   ;2
       STY    NUSIZ1                  ;3
       BEQ    LF48E                   ;2
LF440:
       NOP                            ;2
       BNE    LF48E                   ;2
LF443:
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       LDA    #$02                    ;2
       BNE    LF49F                   ;2
LF44D:
       STA    WSYNC                   ;3
       STY    ENABL                   ;3
       DEX                            ;2
       TXA                            ;2
       SBC    $B8                     ;3
       BEQ    LF407                   ;2
       CMP    #$14                    ;2
       BCS    LF412                   ;2
       TAY                            ;2
       LDA    ($C8),Y                 ;5
       STA    GRP1                    ;3
       NOP                            ;2
       NOP                            ;2
LF462:
       TXA                            ;2
       SEC                            ;2
       SBC    $B7                     ;3
       BEQ    LF41C                   ;2
       CMP    #$14                    ;2
       BCS    LF427                   ;2
       TAY                            ;2
       LDA    ($C6),Y                 ;5
       STA    GRP0                    ;3
LF471:
       LDY    #$00                    ;2
LF473:
       DEX                            ;2
       TXA                            ;2
       SEC                            ;2
       SBC    $B8                     ;3
       CMP    #$14                    ;2
       STY    NUSIZ0                  ;3
       BCS    LF42C                   ;2
       NOP                            ;2
       TAY                            ;2
       STA    HMOVE                   ;3
       LDA    ($C8),Y                 ;5
       STA    GRP1                    ;3
       LDA    ($CC),Y                 ;5
       EOR    $82                     ;3
       STA    COLUP1                  ;3
       STA    RESMP1                  ;3
LF48E:
       TXA                            ;2
       SEC                            ;2
       SBC    $B7                     ;3
       CMP    #$14                    ;2
       BCS    LF443                   ;2
       TAY                            ;2
       LDA    ($C6),Y                 ;5
       STA    GRP0                    ;3
       LDA    ($CA),Y                 ;5
       EOR    $82                     ;3
LF49F:
       LDY    #$01                    ;2
       CPX    $DB                     ;3
       STA    COLUP0                  ;3
       BNE    LF4A8                   ;2
       INY                            ;2
LF4A8:
       CPX    #$05                    ;2
       STA    RESMP0                  ;3
       BCS    LF44D                   ;2
LF4AE:
       STA    WSYNC                   ;3
       STY    ENABL                   ;3
       DEX                            ;2
       CPX    #$04                    ;2
       BCS    LF4BB                   ;2
       LDA    #$F0                    ;2
       STA    PF2                     ;3
LF4BB:
       STA    WSYNC                   ;3
       DEX                            ;2
       BEQ    LF4C9                   ;2
       LDY    #$01                    ;2
       CPX    $DB                     ;3
       BNE    LF4C7                   ;2
       INY                            ;2
LF4C7:
       BNE    LF4AE                   ;2
LF4C9:
       STX    VDELP0                  ;3
       DEX                            ;2
       STX    PF2                     ;3
       STX    PF1                     ;3
       LDX    #$06                    ;2
       STX    REFP0                   ;3
       STX    REFP1                   ;3
       SEC                            ;2
       LDA    #$C7                    ;2
       LDY    #$D0                    ;2
       STY    HMP0                    ;3
       LDY    #$C0                    ;2
       STY    HMP1                    ;3
       STA    RESP1                   ;3
       STA    RESP0                   ;3
       STA    WSYNC                   ;3
       STA    HMOVE                   ;3
LF4E9:
       STA    $CA,X                   ;4
       SBC    #$07                    ;2
       DEX                            ;2
       DEX                            ;2
       BPL    LF4E9                   ;2
       INX                            ;2
       TXS                            ;2
       LDX    #$01                    ;2
       JSR    LFD03                   ;6
       LDY    #$21                    ;2
       STY    TIM64T                  ;4
       JMP    LFA0F                   ;3
LF500:
       LDY    INTIM                   ;4
       BNE    LF500                   ;2
       INC    $84                     ;5
       BNE    LF522                   ;2
       LDA    $8C                     ;3
       CMP    #$7F                    ;2
       BEQ    LF513                   ;2
       INC    $8C                     ;5
       BNE    LF522                   ;2
LF513:
       LDX    #$03                    ;2
       LDA    #$F1                    ;2
LF517:
       CLC                            ;2
       ADC    #$20                    ;2
       STA    $B5,X                   ;4
       DEX                            ;2
       BPL    LF517                   ;2
       SEC                            ;2
       ROR    $8C                     ;5
LF522:
       LDX    #$03                    ;2
       STX    WSYNC                   ;3
       STX    VSYNC                   ;3
       STX    VBLANK                  ;3
       DEY                            ;2
       LDA    $F7                     ;3
       BNE    LF531                   ;2
       LDY    #$0F                    ;2
LF531:
       LDA    #$00                    ;2
       BIT    $8C                     ;3
       BPL    LF53E                   ;2
       TYA                            ;2
       AND    #$F7                    ;2
       TAY                            ;2
       LDA    $8C                     ;3
       ASL                            ;2
LF53E:
       AND    #$F7                    ;2
       STY    $83                     ;3
       LDY    $83                     ;3
       BMI    LF548                   ;2
       AND    #$0F                    ;2
LF548:
       STA    $82                     ;3
       BIT    $8C                     ;3
       BPL    LF550                   ;2
       EOR    #$80                    ;2
LF550:
       STA    $F9                     ;3
LF552:
       STA    WSYNC                   ;3
       DEX                            ;2
       BNE    LF552                   ;2
       STX    VSYNC                   ;3
       LDY    #$2D                    ;2
       STY    TIM64T                  ;4
       LDA    SWCHB                   ;4
       LSR                            ;2
       BCS    LF57C                   ;2
       LDA    #$40                    ;2
       STA    $85                     ;3
       LDX    #$89                    ;2
       LDA    #$03                    ;2
       STA    $87                     ;3
       LDA    #$00                    ;2
       STA    $86                     ;3
       LDA    #$AB                    ;2
LF574:
       STA    $F8                     ;3
       JSR    LFD43                   ;6
       JMP    LF858                   ;3
LF57C:
       LSR                            ;2
       BCS    LF5AC                   ;2
       LDA    $C1                     ;3
       BEQ    LF587                   ;2
       DEC    $C1                     ;5
       BPL    LF5AE                   ;2
LF587:
       STA    $85                     ;3
       LDY    $80                     ;3
       INY                            ;2
       CPY    #$04                    ;2
       BCC    LF592                   ;2
       LDY    #$00                    ;2
LF592:
       STY    $80                     ;3
       TYA                            ;2
       AND    #$01                    ;2
       STA    $81                     ;3
       INY                            ;2
       STY    $8B                     ;3
       LDA    #$AA                    ;2
       STA    $8A                     ;3
       STA    $87                     ;3
       STA    $86                     ;3
       LDA    #$A4                    ;2
       LDX    #$8C                    ;2
       STX    $89                     ;3
       BNE    LF574                   ;2
LF5AC:
       STX    $C1                     ;3
LF5AE:
       LDA    $88                     ;3
       BNE    LF5B4                   ;2
       LDA    #$FF                    ;2
LF5B4:
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       EOR    $88                     ;3
       ASL                            ;2
       ROL    $88                     ;5
       LDA    $85                     ;3
       BEQ    LF5C8                   ;2
       BMI    LF5CB                   ;2
       DEC    $85                     ;5
       BNE    LF5C8                   ;2
       DEC    $85                     ;5
LF5C8:
       JMP    LF858                   ;3
LF5CB:
       LDA    $84                     ;3
       AND    #$03                    ;2
       CMP    #$02                    ;2
       BNE    LF5D6                   ;2
       JSR    LFD71                   ;6
LF5D6:
       LDA    $84                     ;3
       AND    #$03                    ;2
       BNE    LF5C8                   ;2
       LDX    #$01                    ;2
LF5DE:
       STX    $8D                     ;3
       LDA    #$00                    ;2
       STA    $8E                     ;3
       LDX    $8D                     ;3
       LDA    SWCHB                   ;4
       AND    LFE3D,X                 ;4
       BEQ    LF5F9                   ;2
       LDA    $84                     ;3
       AND    #$0F                    ;2
       CMP    #$03                    ;2
       BCS    LF5F9                   ;2
       JMP    LF657                   ;3
LF5F9:
       LDA    SWCHA                   ;4
       LDX    $8D                     ;3
       BEQ    LF60B                   ;2
       AND    #$0F                    ;2
       LDY    $81                     ;3
       BNE    LF60F                   ;2
       LDA    $F3                     ;3
       JMP    LF60F                   ;3
LF60B:
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
LF60F:
       EOR    #$0F                    ;2
       BEQ    LF615                   ;2
       INC    $8E                     ;5
LF615:
       TAY                            ;2
       LDA    $EC,X                   ;4
       TAX                            ;2
       LDA    $A2,X                   ;4
       BNE    LF651                   ;2
       LDA    $8E                     ;3
       STA    $A6,X                   ;4
       TYA                            ;2
       LSR                            ;2
       BCC    LF629                   ;2
       INC    $B5,X                   ;6
       INC    $B5,X                   ;6
LF629:
       LSR                            ;2
       BCC    LF630                   ;2
       DEC    $B5,X                   ;6
       DEC    $B5,X                   ;6
LF630:
       LSR                            ;2
       BCC    LF641                   ;2
       DEC    $B9,X                   ;6
       LDY    #$FF                    ;2
       STY    $BD,X                   ;4
       LDY    #$40                    ;2
       STY    $D6,X                   ;4
       LDY    #$1F                    ;2
       STY    $D2,X                   ;4
LF641:
       LSR                            ;2
       BCC    LF651                   ;2
       INC    $B9,X                   ;6
       LDY    #$F0                    ;2
       STY    $D6,X                   ;4
       LDY    #$00                    ;2
       STY    $BD,X                   ;4
       DEY                            ;2
       STY    $D2,X                   ;4
LF651:
       CPX    #$02                    ;2
       BCC    LF657                   ;2
       DEX                            ;2
       DEX                            ;2
LF657:
       DEX                            ;2
       BMI    LF65D                   ;2
       JMP    LF5DE                   ;3
LF65D:
       LDX    #$03                    ;2
LF65F:
       LDA    $84                     ;3
       AND    #$07                    ;2
       BNE    LF68F                   ;2
       LDA    $A6,X                   ;4
       BEQ    LF677                   ;2
       LDA    #$00                    ;2
       STA    $A6,X                   ;4
       INC    $9A,X                   ;6
       LDA    $9A,X                   ;4
       CMP    #$07                    ;2
       BNE    LF677                   ;2
       LDA    #$01                    ;2
LF677:
       STA    $9A,X                   ;4
       TAY                            ;2
       LDA    $A2,X                   ;4
       BEQ    LF682                   ;2
       DEC    $A2,X                   ;6
       LDY    #$07                    ;2
LF682:
       LDA    LFFD2,Y                 ;4
       STA    $8E                     ;3
       TXA                            ;2
       ASL                            ;2
       TAY                            ;2
       LDA    $8E                     ;3
       STA.wy $C2,Y                   ;5
LF68F:
       DEX                            ;2
       BPL    LF65F                   ;2
       LDX    #$01                    ;2
       LDY    $81                     ;3
       BNE    LF69D                   ;2
       LDA    $F4                     ;3
       JMP    LF69F                   ;3
LF69D:
       LDA    REFP1,X                 ;4
LF69F:
       STA    $DC,X                   ;4
       BMI    LF6C2                   ;2
       LDA    $EC,X                   ;4
       TAX                            ;2
       LDA    $A2,X                   ;4
       BEQ    LF6B0                   ;2
       LDA    #$00                    ;2
       STA    $9E,X                   ;4
       BEQ    LF6BC                   ;2
LF6B0:
       LDA    $9E,X                   ;4
       BNE    LF6BC                   ;2
       INC    $9E,X                   ;6
       LDA    $AA                     ;3
       ORA    #$08                    ;2
       STA    $AA                     ;3
LF6BC:
       CPX    #$02                    ;2
       BCC    LF6C2                   ;2
       DEX                            ;2
       DEX                            ;2
LF6C2:
       DEX                            ;2
       BPL    LF69D                   ;2
       LDX    #$03                    ;2
LF6C7:
       LDA    $84                     ;3
       AND    #$03                    ;2
       BNE    LF6E5                   ;2
       LDA    $9E,X                   ;4
       BEQ    LF6E5                   ;2
       INC    $9E,X                   ;6
       LDA    $9E,X                   ;4
       CMP    #$08                    ;2
       BCC    LF6E5                   ;2
       LDA    #$00                    ;2
       STA    $9E,X                   ;4
       LDA    $D2,X                   ;4
       ORA    #$0F                    ;2
       STA    $D2,X                   ;4
       BNE    LF6EF                   ;2
LF6E5:
       LDA    $D2,X                   ;4
       LDY    $9E,X                   ;4
       BEQ    LF719                   ;2
       AND    #$F0                    ;2
       STA    $D2,X                   ;4
LF6EF:
       LDA    $9E,X                   ;4
       ASL                            ;2
       TAY                            ;2
       TXA                            ;2
       ASL                            ;2
       TAX                            ;2
       BEQ    LF709                   ;2
       CPX    #$04                    ;2
       BEQ    LF709                   ;2
       LDA    LFFEA,Y                 ;4
       STA    $C2,X                   ;4
       LDA    LFFEB,Y                 ;4
       STA    $C3,X                   ;4
       JMP    LF713                   ;3
LF709:
       LDA    LFFDA,Y                 ;4
       STA    $C2,X                   ;4
       LDA    LFFDB,Y                 ;4
       STA    $C3,X                   ;4
LF713:
       TXA                            ;2
       LSR                            ;2
       TAX                            ;2
       JMP    LF71D                   ;3
LF719:
       ORA    #$0F                    ;2
       STA    $D2,X                   ;4
LF71D:
       DEX                            ;2
       BPL    LF6C7                   ;2
       LDX    #$02                    ;2
LF722:
       LDA    #$00                    ;2
       STA    $8E                     ;3
       STA    $8F                     ;3
       LDA    $B5,X                   ;4
       SEC                            ;2
       SBC    $B6,X                   ;4
       BMI    LF737                   ;2
       INC    $8E                     ;5
       CMP    #$04                    ;2
       BCS    LF746                   ;2
       BCC    LF73B                   ;2
LF737:
       CMP    #$FB                    ;2
       BCC    LF74D                   ;2
LF73B:
       LDA    $B9,X                   ;4
       SEC                            ;2
       SBC    $BA,X                   ;4
       BMI    LF74B                   ;2
       INC    $8F                     ;5
       CMP    #$08                    ;2
LF746:
       BCC    LF74F                   ;2
LF748:
       JMP    LF818                   ;3
LF74B:
       CMP    #$F8                    ;2
LF74D:
       BCC    LF748                   ;2
LF74F:
       LDA    $DA                     ;3
       BMI    LF757                   ;2
       AND    #$01                    ;2
       BNE    LF765                   ;2
LF757:
       LDA    $84                     ;3
       LDY    $8A                     ;3
       CPY    $8B                     ;3
       BCS    LF763                   ;2
       CMP    #$40                    ;2
       BCS    LF765                   ;2
LF763:
       STX    $F4                     ;3
LF765:
       LDA    $A2,X                   ;4
       BEQ    LF76C                   ;2
       JMP    LF7EE                   ;3
LF76C:
       LDA    $9E,X                   ;4
       BEQ    LF7B0                   ;2
       LDA    $88                     ;3
       AND    #$07                    ;2
       CMP    #$04                    ;2
       BNE    LF7B0                   ;2
       CPX    #$02                    ;2
       BNE    LF782                   ;2
       LDA    $B8                     ;3
       CMP    #$13                    ;2
       BCC    LF7B0                   ;2
LF782:
       LDA    $88                     ;3
       AND    #$1F                    ;2
       ORA    #$08                    ;2
       STA    $A3,X                   ;4
       LDA    $AA                     ;3
       ORA    #$10                    ;2
       STA    $AA                     ;3
       INX                            ;2
       CPX    $DA                     ;3
       BNE    LF7AF                   ;2
       LDY    #$FF                    ;2
       STY    $DA                     ;3
       INY                            ;2
       LDA    $88                     ;3
       STA    $E2                     ;3
       BPL    LF7A1                   ;2
       DEY                            ;2
LF7A1:
       STY    $E0                     ;3
       LDY    #$00                    ;2
       LDA    $88                     ;3
       ASL                            ;2
       STA    $E3                     ;3
       BPL    LF7AD                   ;2
       DEY                            ;2
LF7AD:
       STY    $E1                     ;3
LF7AF:
       DEX                            ;2
LF7B0:
       LDA    $9F,X                   ;4
       BEQ    LF7EE                   ;2
       LDA    $88                     ;3
       AND    #$07                    ;2
       BNE    LF7EE                   ;2
       CPX    #$00                    ;2
       BNE    LF7C4                   ;2
       LDA    $B5                     ;3
       CMP    #$81                    ;2
       BCS    LF7EE                   ;2
LF7C4:
       LDA    $88                     ;3
       AND    #$1F                    ;2
       ORA    #$08                    ;2
       STA    $A2,X                   ;4
       LDA    $AA                     ;3
       ORA    #$10                    ;2
       STA    $AA                     ;3
       CPX    $DA                     ;3
       BNE    LF7EE                   ;2
       LDY    #$FF                    ;2
       STY    $DA                     ;3
       INY                            ;2
       LDA    $88                     ;3
       STA    $E2                     ;3
       DEY                            ;2
       STY    $E0                     ;3
       LDY    #$00                    ;2
       LDA    $88                     ;3
       ASL                            ;2
       STA    $E3                     ;3
       BPL    LF7EC                   ;2
       DEY                            ;2
LF7EC:
       STY    $E1                     ;3
LF7EE:
       LDA    $AA                     ;3
       ORA    #$04                    ;2
       STA    $AA                     ;3
       LDA    $8E                     ;3
       BEQ    LF802                   ;2
       INC    $B5,X                   ;6
       INC    $B5,X                   ;6
       DEC    $B6,X                   ;6
       DEC    $B6,X                   ;6
       BNE    LF80A                   ;2
LF802:
       DEC    $B5,X                   ;6
       DEC    $B5,X                   ;6
       INC    $B6,X                   ;6
       INC    $B6,X                   ;6
LF80A:
       LDA    $8F                     ;3
       BEQ    LF814                   ;2
       INC    $B9,X                   ;6
       DEC    $BA,X                   ;6
       BNE    LF818                   ;2
LF814:
       DEC    $B9,X                   ;6
       INC    $BA,X                   ;6
LF818:
       DEX                            ;2
       BMI    LF81E                   ;2
       JMP    LF722                   ;3
LF81E:
       LDX    #$03                    ;2
LF820:
       LDA    $A2,X                   ;4
       BEQ    LF82A                   ;2
       LDA    $D2,X                   ;4
       AND    #$F0                    ;2
       STA    $D2,X                   ;4
LF82A:
       DEX                            ;2
       BPL    LF820                   ;2
       LDX    #$01                    ;2
LF82F:
       LDA    $EC,X                   ;4
       EOR    #$02                    ;2
       TAX                            ;2
       LDA    $D2,X                   ;4
       AND    #$F0                    ;2
       STA    $D2,X                   ;4
       CPX    #$02                    ;2
       BCC    LF840                   ;2
       DEX                            ;2
       DEX                            ;2
LF840:
       DEX                            ;2
       BPL    LF82F                   ;2
       LDX    #$03                    ;2
LF845:
       LDA    $B9,X                   ;4
       CMP    #$32                    ;2
       BCS    LF84D                   ;2
       LDA    #$32                    ;2
LF84D:
       CMP    #$79                    ;2
       BCC    LF853                   ;2
       LDA    #$78                    ;2
LF853:
       STA    $B9,X                   ;4
       DEX                            ;2
       BPL    LF845                   ;2
LF858:
       LDX    #$03                    ;2
LF85A:
       LDA    $DB                     ;3
       SEC                            ;2
       SBC    $B5,X                   ;4
       BCS    LF863                   ;2
       EOR    #$FF                    ;2
LF863:
       STA    $8D                     ;3
       LDA    $B4                     ;3
       SEC                            ;2
       SBC    $B9,X                   ;4
       BCS    LF86E                   ;2
       EOR    #$FF                    ;2
LF86E:
       CLC                            ;2
       ADC    $8D                     ;3
       STA    $8D,X                   ;4
       DEX                            ;2
       BPL    LF85A                   ;2
       LDX    #$01                    ;2
LF878:
       LDA    $8D,X                   ;4
       CMP    $8F,X                   ;4
       BCS    LF882                   ;2
       TXA                            ;2
       JMP    LF886                   ;3
LF882:
       TXA                            ;2
       CLC                            ;2
       ADC    #$02                    ;2
LF886:
       STA    $EC,X                   ;4
       DEX                            ;2
       BPL    LF878                   ;2
       LDA    $B3                     ;3
       CMP    #$37                    ;2
       BCS    LF898                   ;2
       LDX    #$03                    ;2
       STX    $ED                     ;3
       DEX                            ;2
       STX    $EC                     ;3
LF898:
       LDA    $B3                     ;3
       CMP    #$5F                    ;2
       BCC    LF8A5                   ;2
       LDX    #$00                    ;2
       STX    $EC                     ;3
       INX                            ;2
       STX    $ED                     ;3
LF8A5:
       LDX    #$03                    ;2
LF8A7:
       LDA    $A2,X                   ;4
       BEQ    LF8B5                   ;2
       TXA                            ;2
       AND    #$01                    ;2
       TAY                            ;2
       TXA                            ;2
       EOR    #$02                    ;2
       STA.wy $EC,Y                   ;5
LF8B5:
       DEX                            ;2
       BPL    LF8A7                   ;2
       LDX    #$04                    ;2
LF8BA:
       LDA    $D2,X                   ;4
       LDY    $8C                     ;3
       BPL    LF8C4                   ;2
       AND    #$F0                    ;2
       STA    $D2,X                   ;4
LF8C4:
       DEX                            ;2
       BPL    LF8BA                   ;2
       LDX    #$01                    ;2
LF8C9:
       LDA    $B5,X                   ;4
       CLC                            ;2
       ADC    #$FC                    ;2
       AND    #$FE                    ;2
       CMP    $DB                     ;3
       BEQ    LF8D7                   ;2
       CLC                            ;2
       ADC    #$02                    ;2
LF8D7:
       STA    $DE,X                   ;4
       DEX                            ;2
       BPL    LF8C9                   ;2
       LDX    #$03                    ;2
LF8DE:
       LDA    LF1F0,X                 ;4
       CMP    $B5,X                   ;4
       BCS    LF8E7                   ;2
       STA    $B5,X                   ;4
LF8E7:
       LDA    LF1F4,X                 ;4
       CMP    $B5,X                   ;4
       BCC    LF8F0                   ;2
       STA    $B5,X                   ;4
LF8F0:
       DEX                            ;2
       BPL    LF8DE                   ;2
       LDA    $DA                     ;3
       BEQ    LF8FB                   ;2
       LDA    $EC                     ;3
       BEQ    LF90C                   ;2
LF8FB:
       LDA    $B7                     ;3
       CMP    $B8                     ;3
       BCS    LF903                   ;2
       LDA    $B8                     ;3
LF903:
       CLC                            ;2
       ADC    #$22                    ;2
       CMP    $B5                     ;3
       BCC    LF90C                   ;2
       STA    $B5                     ;3
LF90C:
       LDA    $ED                     ;3
       CMP    #$01                    ;2
       BEQ    LF91D                   ;2
       LDA    $B8                     ;3
       CLC                            ;2
       ADC    #$22                    ;2
       CMP    $B6                     ;3
       BCC    LF91D                   ;2
       STA    $B6                     ;3
LF91D:
       LDA    $EC                     ;3
       BNE    LF92C                   ;2
       LDA    $DE                     ;3
       SEC                            ;2
       SBC    #$21                    ;2
       CMP    $B7                     ;3
       BCS    LF92C                   ;2
       STA    $B7                     ;3
LF92C:
       LDA    $DE                     ;3
       CMP    $DF                     ;3
       BCC    LF934                   ;2
       LDA    $DF                     ;3
LF934:
       SEC                            ;2
       SBC    #$1D                    ;2
       CMP    $B8                     ;3
       BCS    LF93D                   ;2
       STA    $B8                     ;3
LF93D:
       LDX    #$01                    ;2
LF93F:
       LDA    $BB,X                   ;4
       JSR    LFCE4                   ;6
       STA    $E4,X                   ;4
       STY    $E6,X                   ;4
       DEX                            ;2
       BPL    LF93F                   ;2
       LDX    #$22                    ;2
       LDA    $F7                     ;3
       BNE    LF953                   ;2
       LDX    #$36                    ;2
LF953:
       STX    $CA                     ;3
       INX                            ;2
       STX    $CC                     ;3
       BNE    LF981                   ;2
LF95A:
       STA    $91                     ;3
       LDA    $D7                     ;3
       STA    $E9                     ;3
       BNE    LF9A4                   ;2
LF962:
       LDA    #$00                    ;2
       STA    $91                     ;3
       LDA    #$FF                    ;2
       STA    $E8                     ;3
       BNE    LF9A4                   ;2
LF96C:
       LDY    #$00                    ;2
       STY    $92                     ;3
       CMP    #$FF                    ;2
       BNE    LF97A                   ;2
       LDY    #$20                    ;2
       STY    $94                     ;3
       BNE    LF9BE                   ;2
LF97A:
       STY    $94                     ;3
       DEY                            ;2
       STY    $EA                     ;3
       BNE    LF9BE                   ;2
LF981:
       LDA    #$00                    ;2
       STA    $E8                     ;3
       STA    $EA                     ;3
       LDA    $D3                     ;3
       STA    $E9                     ;3
       LDA    $DE                     ;3
       SEC                            ;2
       SBC    #$03                    ;2
       SEC                            ;2
       SBC    $B6                     ;3
       STA    $8D                     ;3
       BEQ    LF95A                   ;2
       CMP    #$14                    ;2
       BCS    LF962                   ;2
       TAY                            ;2
       LDA    ($C4),Y                 ;5
       STA    $91                     ;3
       LDA    ($CC),Y                 ;5
       STA    $E8                     ;3
LF9A4:
       LDA    $8D                     ;3
       SEC                            ;2
       SBC    #$01                    ;2
       CMP    #$14                    ;2
       BCS    LF96C                   ;2
       TAY                            ;2
       LDA    ($C4),Y                 ;5
       STA    $92                     ;3
       LDA    ($CC),Y                 ;5
       EOR    $82                     ;3
       STA    $93                     ;3
       STA    $EA                     ;3
       LDA    #$00                    ;2
       STA    $94                     ;3
LF9BE:
       JMP    LF9D9                   ;3
LF9C1:
       STA    $95                     ;3
       LDA    $D8                     ;3
       STA    $97                     ;3
       LDY    #$20                    ;2
       BNE    LF9F4                   ;2
LF9CB:
       LDA    #$00                    ;2
       STA    $95                     ;3
       BEQ    LF9F2                   ;2
LF9D1:
       LDA    #$00                    ;2
       STA    $98                     ;3
       LDA    #$02                    ;2
       BNE    LFA0A                   ;2
LF9D9:
       LDA    $D4                     ;3
       STA    $97                     ;3
       LDA    $DF                     ;3
       SEC                            ;2
       SBC    #$03                    ;2
       SEC                            ;2
       SBC    $B7                     ;3
       STA    $8D                     ;3
       BEQ    LF9C1                   ;2
       CMP    #$14                    ;2
       BCS    LF9CB                   ;2
       TAY                            ;2
       LDA    ($C6),Y                 ;5
       STA    $95                     ;3
LF9F2:
       LDY    #$00                    ;2
LF9F4:
       STY    $96                     ;3
       LDA    $8D                     ;3
       SEC                            ;2
       SBC    #$01                    ;2
       CMP    #$14                    ;2
       BCS    LF9D1                   ;2
       TAY                            ;2
       LDA    ($C6),Y                 ;5
       STA    $98                     ;3
       LDA    ($CA),Y                 ;5
       EOR    $82                     ;3
       STA    $99                     ;3
LFA0A:
       STA    $EB                     ;3
       JMP    LF01D                   ;3
LFA0F:
       LDA    $85                     ;3
       BMI    LFA16                   ;2
       JMP    LFC3C                   ;3
LFA16:
       LDA    $B0                     ;3
       BEQ    LFA1D                   ;2
       JMP    LFC30                   ;3
LFA1D:
       LDA    $AE                     ;3
       BEQ    LFA23                   ;2
       DEC    $AE                     ;5
LFA23:
       LDX    #$03                    ;2
LFA25:
       CPX    $DA                     ;3
       BEQ    LFA87                   ;2
       LDA    $A2,X                   ;4
       BNE    LFA87                   ;2
       LDA    $B4                     ;3
       SEC                            ;2
       SBC    $B9,X                   ;4
       LDY    $BD,X                   ;4
       BEQ    LFA46                   ;2
       CMP    #$80                    ;2
       BCS    LFA40                   ;2
       CMP    #$08                    ;2
       BCS    LFA87                   ;2
       BCC    LFA4A                   ;2
LFA40:
       CMP    #$F9                    ;2
       BCC    LFA87                   ;2
       BCS    LFA4A                   ;2
LFA46:
       CMP    #$12                    ;2
       BCS    LFA87                   ;2
LFA4A:
       LDA    $B3                     ;3
       SEC                            ;2
       SBC    $B5,X                   ;4
       BMI    LFA57                   ;2
       CMP    #$04                    ;2
       BCS    LFA87                   ;2
       BCC    LFA5B                   ;2
LFA57:
       CMP    #$FF                    ;2
       BCC    LFA87                   ;2
LFA5B:
       CPX    $AD                     ;3
       BNE    LFA63                   ;2
       LDA    $AE                     ;3
       BNE    LFA87                   ;2
LFA63:
       LDA    $DA                     ;3
       BMI    LFA6E                   ;2
       TXA                            ;2
       EOR    $88                     ;3
       AND    #$03                    ;2
       BNE    LFA87                   ;2
LFA6E:
       LDA    $AA                     ;3
       ORA    #$02                    ;2
       STA    $AA                     ;3
       LDA    #$00                    ;2
       STA    $AE                     ;3
       STX    $DA                     ;3
       LDX    #$3F                    ;2
       STX    $EE                     ;3
       LDX    #$03                    ;2
LFA80:
       STA    $E0,X                   ;4
       DEX                            ;2
       BPL    LFA80                   ;2
       BMI    LFA8A                   ;2
LFA87:
       DEX                            ;2
       BPL    LFA25                   ;2
LFA8A:
       LDX    $DA                     ;3
       BPL    LFA91                   ;2
       JMP    LFB21                   ;3
LFA91:
       DEC    $EE                     ;5
       LDA    $EE                     ;3
       BPL    LFA99                   ;2
       LDA    #$3F                    ;2
LFA99:
       STA    $EE                     ;3
       LDA    $EE                     ;3
       LSR                            ;2
       LSR                            ;2
       CMP    #$08                    ;2
       BCC    LFAA5                   ;2
       EOR    #$0F                    ;2
LFAA5:
       TAY                            ;2
       LDA    $BD,X                   ;4
       BEQ    LFAB7                   ;2
       CLC                            ;2
       TYA                            ;2
       EOR    #$07                    ;2
       ADC    #$F7                    ;2
       CLC                            ;2
       ADC    $B9,X                   ;4
       STA    $B4                     ;3
       BNE    LFABF                   ;2
LFAB7:
       CLC                            ;2
       TYA                            ;2
       ADC    #$0B                    ;2
       ADC    $B9,X                   ;4
       STA    $B4                     ;3
LFABF:
       LDY    #$00                    ;2
       TXA                            ;2
       AND    #$01                    ;2
       BEQ    LFAC8                   ;2
       LDY    #$02                    ;2
LFAC8:
       TYA                            ;2
       CLC                            ;2
       ADC    $B5,X                   ;4
       STA    $B3                     ;3
       LDA    $DA                     ;3
       AND    #$01                    ;2
       TAX                            ;2
       LDA    $DC,X                   ;4
       BMI    LFB21                   ;2
       LDX    $DA                     ;3
       STX    $AD                     ;3
       LDA    #$30                    ;2
       STA    $AE                     ;3
       LDA    #$FF                    ;2
       STA    $DA                     ;3
       LDA    $EE                     ;3
       CMP    #$20                    ;2
       BCC    LFAEB                   ;2
       EOR    #$3F                    ;2
LFAEB:
       LDY    $BD,X                   ;4
       BEQ    LFAF1                   ;2
       EOR    #$3F                    ;2
LFAF1:
       AND    #$1F                    ;2
       STA    $8D                     ;3
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       TAY                            ;2
       LDA    LF1A3,Y                 ;4
       STA    $E1                     ;3
       LDA    $8D                     ;3
       AND    #$07                    ;2
       TAY                            ;2
       LDA    LF1F8,Y                 ;4
       STA    $E3                     ;3
       TXA                            ;2
       AND    #$01                    ;2
       BNE    LFB13                   ;2
       LDA    #$00                    ;2
       LDY    #$FE                    ;2
       BNE    LFB17                   ;2
LFB13:
       LDA    #$00                    ;2
       LDY    #$02                    ;2
LFB17:
       STA    $E2                     ;3
       STY    $E0                     ;3
       LDA    $AA                     ;3
       ORA    #$02                    ;2
       STA    $AA                     ;3
LFB21:
       LDA    $84                     ;3
       AND    #$01                    ;2
       BEQ    LFB2A                   ;2
       JMP    LFC3C                   ;3
LFB2A:
       LDX    #$01                    ;2
LFB2C:
       LDA    $80                     ;3
       CMP    #$02                    ;2
       BCS    LFB5D                   ;2
       LDA    $E0,X                   ;4
       STA    $8E                     ;3
       LDA    $E2,X                   ;4
       STA    $8D                     ;3
       LDY    #$05                    ;2
LFB3C:
       ROR    $8E                     ;5
       ROR    $8D                     ;5
       DEY                            ;2
       BPL    LFB3C                   ;2
       LDA    $8D                     ;3
       BMI    LFB4A                   ;2
       INY                            ;2
       BEQ    LFB4E                   ;2
LFB4A:
       CMP    #$FF                    ;2
       BCS    LFB5D                   ;2
LFB4E:
       STY    $8E                     ;3
       LDA    $E2,X                   ;4
       SEC                            ;2
       SBC    $8D                     ;3
       STA    $E2,X                   ;4
       LDA    $E0,X                   ;4
       SBC    $8E                     ;3
       STA    $E0,X                   ;4
LFB5D:
       CLC                            ;2
       LDA    $B1,X                   ;4
       ADC    $E2,X                   ;4
       STA    $B1,X                   ;4
       LDA    $B3,X                   ;4
       ADC    $E0,X                   ;4
       STA    $B3,X                   ;4
       DEX                            ;2
       BPL    LFB2C                   ;2
       LDX    #$01                    ;2
LFB6F:
       LDA    $B3,X                   ;4
       CMP    LFFFA,X                 ;4
       BCS    LFB96                   ;2
       LDA    $DA                     ;3
       BPL    LFB80                   ;2
       LDA    $AA                     ;3
       ORA    #$01                    ;2
       STA    $AA                     ;3
LFB80:
       LDA    LFFFA,X                 ;4
       STA    $B3,X                   ;4
       LDA    $E2,X                   ;4
       EOR    #$FF                    ;2
       CLC                            ;2
       ADC    #$01                    ;2
       STA    $E2,X                   ;4
       LDA    $E0,X                   ;4
       EOR    #$FF                    ;2
       ADC    #$00                    ;2
       STA    $E0,X                   ;4
LFB96:
       LDA    $B3,X                   ;4
       CMP    LF10B,X                 ;4
       BCC    LFBC0                   ;2
       LDA    $DA                     ;3
       BPL    LFBA7                   ;2
       LDA    $AA                     ;3
       ORA    #$01                    ;2
       STA    $AA                     ;3
LFBA7:
       LDA    LF10B,X                 ;4
       SEC                            ;2
       SBC    #$02                    ;2
       STA    $B3,X                   ;4
       LDA    $E2,X                   ;4
       EOR    #$FF                    ;2
       CLC                            ;2
       ADC    #$01                    ;2
       STA    $E2,X                   ;4
       LDA    $E0,X                   ;4
       EOR    #$FF                    ;2
       ADC    #$00                    ;2
       STA    $E0,X                   ;4
LFBC0:
       DEX                            ;2
       BPL    LFB6F                   ;2
       LDA    $B3                     ;3
       CMP    #$8F                    ;2
       BCS    LFBCD                   ;2
       CMP    #$07                    ;2
       BCS    LFBFD                   ;2
LFBCD:
       LDA    $B4                     ;3
       LDX    #$03                    ;2
LFBD1:
       CMP    LFFCE,X                 ;4
       BEQ    LFBDB                   ;2
       DEX                            ;2
       BPL    LFBD1                   ;2
       BMI    LFBFD                   ;2
LFBDB:
       CLC                            ;2
       ADC    #$FE                    ;2
       CPX    #$02                    ;2
       BCC    LFBE4                   ;2
       ADC    #$03                    ;2
LFBE4:
       STA    $B4                     ;3
       LDA    $E3                     ;3
       EOR    #$FF                    ;2
       CLC                            ;2
       ADC    #$01                    ;2
       STA    $E3                     ;3
       LDA    $E1                     ;3
       EOR    #$FF                    ;2
       ADC    #$00                    ;2
       STA    $E1                     ;3
       LDA    $AA                     ;3
       ORA    #$01                    ;2
       STA    $AA                     ;3
LFBFD:
       LDA    $B3                     ;3
       AND    #$FE                    ;2
       STA    $DB                     ;3
       LDX    #$01                    ;2
       LDA    $B4                     ;3
       CMP    #$4A                    ;2
       BCC    LFC3C                   ;2
       CMP    #$69                    ;2
       BCS    LFC3C                   ;2
       LDA    $B3                     ;3
       CMP    #$90                    ;2
       BCS    LFC1A                   ;2
       DEX                            ;2
       CMP    #$06                    ;2
       BCS    LFC3C                   ;2
LFC1A:
       LDA    LFE47,X                 ;4
       STA    $AA                     ;3
       LDA    $8A,X                   ;4
       SED                            ;2
       CLC                            ;2
       ADC    #$01                    ;2
       STA    $8A,X                   ;4
       CLD                            ;2
       LDA    #$40                    ;2
       STA    $85                     ;3
       STA    $B0                     ;3
       BNE    LFC3C                   ;2
LFC30:
       LDX    #$8C                    ;2
       JSR    LFD43                   ;6
       LDA    #$40                    ;2
       STA    $85                     ;3
       JMP    LFCB8                   ;3
LFC3C:
       LDX    #$01                    ;2
LFC3E:
       LDA    $AB,X                   ;4
       BEQ    LFC4A                   ;2
       DEC    $AB,X                   ;6
       BNE    LFC4A                   ;2
       LDA    #$00                    ;2
       STA    AUDV0,X                 ;4
LFC4A:
       DEX                            ;2
       BPL    LFC3E                   ;2
       LDA    $AA                     ;3
       STA    $8D                     ;3
       LDX    #$08                    ;2
       CLC                            ;2
LFC54:
       ROL                            ;2
       STA    $8D                     ;3
       BCC    LFC7E                   ;2
       LDY    #$01                    ;2
LFC5B:
       LDA.wy $AB,Y                   ;4
       BNE    LFC7B                   ;2
       LDA    LF1D7,X                 ;4
       STA.wy $AB,Y                   ;5
       LDA    LF1DF,X                 ;4
       STA.wy AUDF0,Y                 ;5
       LDA    LF1E7,X                 ;4
       STA.wy AUDC0,Y                 ;5
       LDA    #$08                    ;2
       STA.wy AUDV0,Y                 ;5
       CLC                            ;2
       JMP    LFC7E                   ;3
LFC7B:
       DEY                            ;2
       BPL    LFC5B                   ;2
LFC7E:
       LDA    $8D                     ;3
       DEX                            ;2
       BPL    LFC54                   ;2
       STA    $AA                     ;3
       LDA    $85                     ;3
       BPL    LFCB8                   ;2
       INC    $AF                     ;5
       LDA    $AF                     ;3
       CMP    #$3C                    ;2
       BNE    LFCB8                   ;2
       LDA    #$00                    ;2
       STA    $AF                     ;3
       SED                            ;2
       LDA    $86                     ;3
       SEC                            ;2
       SBC    #$01                    ;2
       STA    $86                     ;3
       BMI    LFCAD                   ;2
       ORA    $87                     ;3
       BNE    LFCB8                   ;2
       STA    $85                     ;3
       STA    $86                     ;3
       LDA    #$80                    ;2
       STA    $AA                     ;3
       BNE    LFCB8                   ;2
LFCAD:
       LDA    #$59                    ;2
       STA    $86                     ;3
       LDA    $87                     ;3
       SEC                            ;2
       SBC    #$01                    ;2
       STA    $87                     ;3
LFCB8:
       CLD                            ;2
       JMP    LF500                   ;3
LFCBC:
       CLC                            ;2
       ADC    #$25                    ;2
       TAY                            ;2
       AND    #$0F                    ;2
       STA    $8D                     ;3
       TYA                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       TAY                            ;2
       CLC                            ;2
       ADC    $8D                     ;3
       CMP    #$0F                    ;2
       BCC    LFCD4                   ;2
       SBC    #$0F                    ;2
       INY                            ;2
LFCD4:
       EOR    #$07                    ;2
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       STA    HMP0,X                  ;4
       STA    WSYNC                   ;3
LFCDE:
       DEY                            ;2
       BPL    LFCDE                   ;2
       STA    RESP0,X                 ;4
       RTS                            ;6

LFCE4:
       CLC                            ;2
       ADC    #$CE                    ;2
       TAY                            ;2
       AND    #$0F                    ;2
       STA    $8D                     ;3
       TYA                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       TAY                            ;2
       CLC                            ;2
       ADC    $8D                     ;3
       CMP    #$0F                    ;2
       BCC    LFCFC                   ;2
       SBC    #$0F                    ;2
       INY                            ;2
LFCFC:
       EOR    #$07                    ;2
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       RTS                            ;6

LFD03:
       STX    NUSIZ0                  ;3
       STX    NUSIZ1                  ;3
LFD07:
       LDY    #$06                    ;2
       LDA    ($D0),Y                 ;5
       STA    $8E                     ;3
LFD0D:
       STA    WSYNC                   ;3
       STA    $8E                     ;3
       LDA    $F1                     ;3
       STA    COLUP1                  ;3
       STA    COLUP0                  ;3
       LDA    ($CA),Y                 ;5
       STA    GRP1                    ;3
       LDA    ($CC),Y                 ;5
       STA    GRP0                    ;3
       STY    $8D                     ;3
       LDA    VSYNC                   ;3
       LDA    ($CE),Y                 ;5
       LDY    $F2                     ;3
       LDX    $8E                     ;3
       STA    GRP1                    ;3
       STX    GRP0                    ;3
       STY    COLUP1                  ;3
       STY    COLUP0                  ;3
       LDY    $8D                     ;3
       DEY                            ;2
       LDA    ($D0),Y                 ;5
       CPY    #$00                    ;2
       BPL    LFD0D                   ;2
       LDX    #$00                    ;2
       STX    GRP0                    ;3
       STX    GRP1                    ;3
       STX    HMCLR                   ;3
       RTS                            ;6

LFD43:
       LDY    #$00                    ;2
       STY    AUDV0                   ;3
       STY    AUDV1                   ;3
LFD49:
       STY    VSYNC,X                 ;4
       INX                            ;2
       CPX    #$B1                    ;2
       BNE    LFD49                   ;2
       LDX    #$2E                    ;2
LFD52:
       LDA    LFEF4,X                 ;4
       STA    $B1,X                   ;4
       DEX                            ;2
       BPL    LFD52                   ;2
       INX                            ;2
       LDA    $88                     ;3
       STA    $E2                     ;3
       BMI    LFD62                   ;2
       DEX                            ;2
LFD62:
       STX    $E0                     ;3
       LDX    #$00                    ;2
       LDA    $88                     ;3
       ASL                            ;2
       STA    $E3                     ;3
       BMI    LFD6E                   ;2
       DEX                            ;2
LFD6E:
       STX    $E1                     ;3
       RTS                            ;6

LFD71:
       LDX    $ED                     ;3
       LDA    $84                     ;3
       AND    #$1F                    ;2
       LDY    $8A                     ;3
       CPY    $8B                     ;3
       BCC    LFD7F                   ;2
       AND    #$07                    ;2
LFD7F:
       CMP    #$02                    ;2
       BNE    LFDD7                   ;2
       LDA    #$FF                    ;2
       STA    $F4                     ;3
       LDA    $DA                     ;3
       BMI    LFDDA                   ;2
       AND    #$01                    ;2
       BEQ    LFDDA                   ;2
       CPX    #$03                    ;2
       BNE    LFD97                   ;2
       LDA    $84                     ;3
       BMI    LFDD3                   ;2
LFD97:
       LDA    $88                     ;3
       AND    #$3F                    ;2
       ADC    #$30                    ;2
       STA    $F6                     ;3
       LDA    $88                     ;3
       ORA    #$78                    ;2
       LDY    $A2                     ;3
       BNE    LFDAD                   ;2
       LDY    $B6                     ;3
       CPY    $B5                     ;3
       BCC    LFDAF                   ;2
LFDAD:
       LDA    #$92                    ;2
LFDAF:
       STA    $F5                     ;3
       LDA    $88                     ;3
       AND    #$1F                    ;2
       ADC    $B3                     ;3
       CMP    #$92                    ;2
       BCC    LFDD7                   ;2
       LDA    $EE                     ;3
       CMP    #$20                    ;2
       BCC    LFDC3                   ;2
       EOR    #$FF                    ;2
LFDC3:
       EOR    $BE                     ;3
       AND    #$1F                    ;2
       LDY    $B4                     ;3
       CPY    #$59                    ;2
       BCS    LFDCF                   ;2
       EOR    #$1F                    ;2
LFDCF:
       CMP    #$10                    ;2
       BCS    LFDD7                   ;2
LFDD3:
       LDA    #$00                    ;2
       STA    $F4                     ;3
LFDD7:
       JMP    LFE04                   ;3
LFDDA:
       LDA    $88                     ;3
       AND    #$07                    ;2
       STA    $8D                     ;3
       LDA    $B3                     ;3
       ADC    #$FA                    ;2
       ADC    $8D                     ;3
       LDY    $DA                     ;3
       BMI    LFDF6                   ;2
       LDY    $84                     ;3
       BMI    LFDF0                   ;2
       ADC    #$F8                    ;2
LFDF0:
       CMP    #$92                    ;2
       BCC    LFDF6                   ;2
       LDA    #$00                    ;2
LFDF6:
       STA    $F5                     ;3
       LDA    $BD,X                   ;4
       AND    #$07                    ;2
       ADC    $B4                     ;3
       ADC    #$F4                    ;2
       ADC    $8D                     ;3
       STA    $F6                     ;3
LFE04:
       LDA    $B5,X                   ;4
       CMP    $F5                     ;3
       BEQ    LFE16                   ;2
       BCS    LFE12                   ;2
       LDA    #$0E                    ;2
       STA    $F3                     ;3
       BNE    LFE16                   ;2
LFE12:
       LDA    #$0D                    ;2
       STA    $F3                     ;3
LFE16:
       LDA    $B9,X                   ;4
       CMP    $F6                     ;3
       BEQ    LFE2C                   ;2
       BCS    LFE26                   ;2
       LDA    $F3                     ;3
       AND    #$07                    ;2
       STA    $F3                     ;3
       BNE    LFE2C                   ;2
LFE26:
       LDA    $F3                     ;3
       AND    #$0B                    ;2
       STA    $F3                     ;3
LFE2C:
       RTS                            ;6

       .byte $00 ; |        | $FE2D
       .byte $00 ; |        | $FE2E
       .byte $00 ; |        | $FE2F
       .byte $00 ; |        | $FE30
       .byte $00 ; |        | $FE31
       .byte $00 ; |        | $FE32
       .byte $00 ; |        | $FE33
       .byte $00 ; |        | $FE34
       .byte $00 ; |        | $FE35
       .byte $00 ; |        | $FE36
       .byte $00 ; |        | $FE37
       .byte $00 ; |        | $FE38
       .byte $00 ; |        | $FE39
       .byte $00 ; |        | $FE3A
       .byte $00 ; |        | $FE3B
       .byte $00 ; |        | $FE3C
LFE3D:
       .byte $40 ; | X      | $FE3D
       .byte $80 ; |X       | $FE3E
LFE3F:
       .byte $0A ; |    X X | $FE3F
       .byte $00 ; |        | $FE40
       .byte $88 ; |X   X   | $FE41
       .byte $2E ; |  X XXX | $FE42
LFE43:
       .byte $08 ; |    X   | $FE43
       .byte $00 ; |        | $FE44
       .byte $06 ; |     XX | $FE45
       .byte $0F ; |    XXXX| $FE46
LFE47:
       .byte $20 ; |  X     | $FE47
       .byte $40 ; | X      | $FE48
       .byte $C3 ; |XX    XX| $FE49
       .byte $82 ; |X     X | $FE4A
       .byte $C2 ; |XX    X | $FE4B
       .byte $42 ; | X    X | $FE4C
       .byte $62 ; | XX   X | $FE4D
       .byte $36 ; |  XX XX | $FE4E
       .byte $3C ; |  XXXX  | $FE4F
       .byte $38 ; |  XXX   | $FE50
       .byte $31 ; |  XX   X| $FE51
       .byte $03 ; |      XX| $FE52
       .byte $33 ; |  XX  XX| $FE53
       .byte $3E ; |  XXXXX | $FE54
       .byte $1E ; |   XXXX | $FE55
       .byte $0E ; |    XXX | $FE56
       .byte $06 ; |     XX | $FE57
       .byte $00 ; |        | $FE58
       .byte $03 ; |      XX| $FE59
       .byte $03 ; |      XX| $FE5A
       .byte $03 ; |      XX| $FE5B
       .byte $03 ; |      XX| $FE5C
       .byte $02 ; |      X | $FE5D
       .byte $82 ; |X     X | $FE5E
       .byte $82 ; |X     X | $FE5F
       .byte $E6 ; |XXX  XX | $FE60
       .byte $FC ; |XXXXXX  | $FE61
       .byte $38 ; |  XXX   | $FE62
       .byte $30 ; |  XX    | $FE63
       .byte $31 ; |  XX   X| $FE64
       .byte $03 ; |      XX| $FE65
       .byte $33 ; |  XX  XX| $FE66
       .byte $3E ; |  XXXXX | $FE67
       .byte $1E ; |   XXXX | $FE68
       .byte $0E ; |    XXX | $FE69
       .byte $06 ; |     XX | $FE6A
       .byte $00 ; |        | $FE6B
       .byte $03 ; |      XX| $FE6C
       .byte $03 ; |      XX| $FE6D
       .byte $03 ; |      XX| $FE6E
       .byte $0C ; |    XX  | $FE6F
       .byte $08 ; |    X   | $FE70
       .byte $28 ; |  X X   | $FE71
       .byte $28 ; |  X X   | $FE72
       .byte $3C ; |  XXXX  | $FE73
       .byte $3C ; |  XXXX  | $FE74
       .byte $38 ; |  XXX   | $FE75
       .byte $30 ; |  XX    | $FE76
       .byte $31 ; |  XX   X| $FE77
       .byte $03 ; |      XX| $FE78
       .byte $33 ; |  XX  XX| $FE79
       .byte $3E ; |  XXXXX | $FE7A
       .byte $1E ; |   XXXX | $FE7B
       .byte $0E ; |    XXX | $FE7C
       .byte $06 ; |     XX | $FE7D
       .byte $00 ; |        | $FE7E
       .byte $03 ; |      XX| $FE7F
       .byte $03 ; |      XX| $FE80
       .byte $03 ; |      XX| $FE81
       .byte $30 ; |  XX    | $FE82
       .byte $20 ; |  X     | $FE83
       .byte $20 ; |  X     | $FE84
       .byte $2C ; |  X XX  | $FE85
       .byte $28 ; |  X X   | $FE86
       .byte $38 ; |  XXX   | $FE87
       .byte $38 ; |  XXX   | $FE88
       .byte $30 ; |  XX    | $FE89
       .byte $31 ; |  XX   X| $FE8A
       .byte $03 ; |      XX| $FE8B
       .byte $33 ; |  XX  XX| $FE8C
       .byte $3E ; |  XXXXX | $FE8D
       .byte $1E ; |   XXXX | $FE8E
       .byte $0E ; |    XXX | $FE8F
       .byte $06 ; |     XX | $FE90
       .byte $00 ; |        | $FE91
       .byte $03 ; |      XX| $FE92
       .byte $03 ; |      XX| $FE93
       .byte $03 ; |      XX| $FE94
       .byte $C0 ; |XX      | $FE95
       .byte $86 ; |X    XX | $FE96
       .byte $C4 ; |XX   X  | $FE97
       .byte $4C ; | X  XX  | $FE98
       .byte $6C ; | XX XX  | $FE99
       .byte $78 ; | XXXX   | $FE9A
       .byte $38 ; |  XXX   | $FE9B
       .byte $30 ; |  XX    | $FE9C
       .byte $00 ; |        | $FE9D
       .byte $30 ; |  XX    | $FE9E
       .byte $30 ; |  XX    | $FE9F
       .byte $3E ; |  XXXXX | $FEA0
       .byte $3E ; |  XXXXX | $FEA1
       .byte $3A ; |  XXX X | $FEA2
       .byte $32 ; |  XX  X | $FEA3
       .byte $06 ; |     XX | $FEA4
       .byte $34 ; |  XX X  | $FEA5
       .byte $34 ; |  XX X  | $FEA6
       .byte $37 ; |  XX XXX| $FEA7
       .byte $C0 ; |XX      | $FEA8
       .byte $86 ; |X    XX | $FEA9
       .byte $C4 ; |XX   X  | $FEAA
       .byte $4C ; | X  XX  | $FEAB
       .byte $6C ; | XX XX  | $FEAC
       .byte $78 ; | XXXX   | $FEAD
       .byte $38 ; |  XXX   | $FEAE
       .byte $30 ; |  XX    | $FEAF
       .byte $00 ; |        | $FEB0
       .byte $30 ; |  XX    | $FEB1
       .byte $30 ; |  XX    | $FEB2
       .byte $3E ; |  XXXXX | $FEB3
       .byte $3E ; |  XXXXX | $FEB4
       .byte $3A ; |  XXX X | $FEB5
       .byte $33 ; |  XX  XX| $FEB6
       .byte $00 ; |        | $FEB7
       .byte $30 ; |  XX    | $FEB8
       .byte $30 ; |  XX    | $FEB9
       .byte $30 ; |  XX    | $FEBA
       .byte $C0 ; |XX      | $FEBB
       .byte $86 ; |X    XX | $FEBC
       .byte $C4 ; |XX   X  | $FEBD
       .byte $4C ; | X  XX  | $FEBE
       .byte $6C ; | XX XX  | $FEBF
       .byte $78 ; | XXXX   | $FEC0
       .byte $3B ; |  XXX XX| $FEC1
       .byte $32 ; |  XX  X | $FEC2
       .byte $06 ; |     XX | $FEC3
       .byte $36 ; |  XX XX | $FEC4
       .byte $34 ; |  XX X  | $FEC5
       .byte $3C ; |  XXXX  | $FEC6
       .byte $3C ; |  XXXX  | $FEC7
       .byte $38 ; |  XXX   | $FEC8
       .byte $38 ; |  XXX   | $FEC9
       .byte $00 ; |        | $FECA
       .byte $30 ; |  XX    | $FECB
       .byte $30 ; |  XX    | $FECC
       .byte $30 ; |  XX    | $FECD
       .byte $C0 ; |XX      | $FECE
       .byte $86 ; |X    XX | $FECF
       .byte $C4 ; |XX   X  | $FED0
       .byte $4C ; | X  XX  | $FED1
       .byte $6C ; | XX XX  | $FED2
       .byte $78 ; | XXXX   | $FED3
       .byte $38 ; |  XXX   | $FED4
       .byte $30 ; |  XX    | $FED5
       .byte $01 ; |       X| $FED6
       .byte $B2 ; |X XX  X | $FED7
       .byte $B6 ; |X XX XX | $FED8
       .byte $BC ; |X XXXX  | $FED9
       .byte $FC ; |XXXXXX  | $FEDA
       .byte $F8 ; |XXXXX   | $FEDB
       .byte $70 ; | XXX    | $FEDC
       .byte $00 ; |        | $FEDD
       .byte $30 ; |  XX    | $FEDE
       .byte $30 ; |  XX    | $FEDF
       .byte $30 ; |  XX    | $FEE0
       .byte $18 ; |   XX   | $FEE1
       .byte $1C ; |   XXX  | $FEE2
       .byte $14 ; |   X X  | $FEE3
       .byte $10 ; |   X    | $FEE4
       .byte $37 ; |  XX XXX| $FEE5
       .byte $3F ; |  XXXXXX| $FEE6
       .byte $39 ; |  XXX  X| $FEE7
       .byte $B5 ; |X XX X X| $FEE8
       .byte $84 ; |X    X  | $FEE9
       .byte $B4 ; |X XX X  | $FEEA
       .byte $B4 ; |X XX X  | $FEEB
       .byte $B4 ; |X XX X  | $FEEC
       .byte $F4 ; |XXXX X  | $FEED
       .byte $FC ; |XXXXXX  | $FEEE
       .byte $78 ; | XXXX   | $FEEF
       .byte $00 ; |        | $FEF0
       .byte $30 ; |  XX    | $FEF1
       .byte $30 ; |  XX    | $FEF2
       .byte $30 ; |  XX    | $FEF3
LFEF4:
       .byte $00 ; |        | $FEF4
       .byte $00 ; |        | $FEF5
       .byte $4A ; | X  X X | $FEF6
       .byte $59 ; | X XX  X| $FEF7
       .byte $85 ; |X    X X| $FEF8
       .byte $3F ; |  XXXXXX| $FEF9
       .byte $55 ; | X X X X| $FEFA
       .byte $0D ; |    XX X| $FEFB
       .byte $50 ; | X X    | $FEFC
       .byte $64 ; | XX  X  | $FEFD
       .byte $45 ; | X   X X| $FEFE
       .byte $50 ; | X X    | $FEFF
       .byte $00 ; |        | $FF00
       .byte $FF ; |XXXXXXXX| $FF01
       .byte $00 ; |        | $FF02
       .byte $FF ; |XXXXXXXX| $FF03
       .byte $20 ; |  X     | $FF04
       .byte $CD ; |XX  XX X| $FF05
       .byte $FE ; |XXXXXXX | $FF06
       .byte $48 ; | X  X   | $FF07
       .byte $FE ; |XXXXXXX | $FF08
       .byte $48 ; | X  X   | $FF09
       .byte $FE ; |XXXXXXX | $FF0A
       .byte $CD ; |XX  XX X| $FF0B
       .byte $FE ; |XXXXXXX | $FF0C
       .byte $5E ; | X XXXX | $FF0D
       .byte $FF ; |XXXXXXXX| $FF0E
       .byte $5E ; | X XXXX | $FF0F
       .byte $FF ; |XXXXXXXX| $FF10
       .byte $5E ; | X XXXX | $FF11
       .byte $FF ; |XXXXXXXX| $FF12
       .byte $5E ; | X XXXX | $FF13
       .byte $FF ; |XXXXXXXX| $FF14
       .byte $F0 ; |XXXX    | $FF15
       .byte $1F ; |   XXXXX| $FF16
       .byte $FF ; |XXXXXXXX| $FF17
       .byte $10 ; |   X    | $FF18
       .byte $F0 ; |XXXX    | $FF19
       .byte $40 ; | X      | $FF1A
       .byte $F0 ; |XXXX    | $FF1B
       .byte $40 ; | X      | $FF1C
       .byte $FF ; |XXXXXXXX| $FF1D
       .byte $4A ; | X  X X | $FF1E
       .byte $FF ; |XXXXXXXX| $FF1F
       .byte $FF ; |XXXXXXXX| $FF20
       .byte $82 ; |X     X | $FF21
       .byte $3C ; |  XXXX  | $FF22
       .byte $44 ; | X   X  | $FF23
       .byte $D4 ; |XX X X  | $FF24
       .byte $44 ; | X   X  | $FF25
       .byte $D4 ; |XX X X  | $FF26
       .byte $44 ; | X   X  | $FF27
       .byte $D4 ; |XX X X  | $FF28
       .byte $44 ; | X   X  | $FF29
       .byte $D4 ; |XX X X  | $FF2A
       .byte $44 ; | X   X  | $FF2B
       .byte $D4 ; |XX X X  | $FF2C
       .byte $84 ; |X    X  | $FF2D
       .byte $FC ; |XXXXXX  | $FF2E
       .byte $84 ; |X    X  | $FF2F
       .byte $FC ; |XXXXXX  | $FF30
       .byte $84 ; |X    X  | $FF31
       .byte $FA ; |XXXXX X | $FF32
       .byte $46 ; | X   XX | $FF33
       .byte $46 ; | X   XX | $FF34
       .byte $46 ; | X   XX | $FF35
       .byte $46 ; | X   XX | $FF36
       .byte $04 ; |     X  | $FF37
       .byte $0C ; |    XX  | $FF38
       .byte $04 ; |     X  | $FF39
       .byte $0C ; |    XX  | $FF3A
       .byte $04 ; |     X  | $FF3B
       .byte $0C ; |    XX  | $FF3C
       .byte $04 ; |     X  | $FF3D
       .byte $0C ; |    XX  | $FF3E
       .byte $04 ; |     X  | $FF3F
       .byte $0C ; |    XX  | $FF40
       .byte $04 ; |     X  | $FF41
       .byte $0C ; |    XX  | $FF42
       .byte $04 ; |     X  | $FF43
       .byte $0C ; |    XX  | $FF44
       .byte $04 ; |     X  | $FF45
       .byte $0E ; |    XXX | $FF46
       .byte $06 ; |     XX | $FF47
       .byte $0E ; |    XXX | $FF48
       .byte $06 ; |     XX | $FF49
       .byte $0E ; |    XXX | $FF4A
       .byte $C0 ; |XX      | $FF4B
       .byte $86 ; |X    XX | $FF4C
       .byte $C4 ; |XX   X  | $FF4D
       .byte $4C ; | X  XX  | $FF4E
       .byte $6C ; | XX XX  | $FF4F
       .byte $78 ; | XXXX   | $FF50
       .byte $38 ; |  XXX   | $FF51
       .byte $30 ; |  XX    | $FF52
       .byte $C0 ; |XX      | $FF53
       .byte $B0 ; |X XX    | $FF54
       .byte $B0 ; |X XX    | $FF55
       .byte $B0 ; |X XX    | $FF56
       .byte $30 ; |  XX    | $FF57
       .byte $30 ; |  XX    | $FF58
       .byte $30 ; |  XX    | $FF59
       .byte $00 ; |        | $FF5A
       .byte $30 ; |  XX    | $FF5B
       .byte $30 ; |  XX    | $FF5C
       .byte $30 ; |  XX    | $FF5D
       .byte $3C ; |  XXXX  | $FF5E
       .byte $66 ; | XX  XX | $FF5F
       .byte $66 ; | XX  XX | $FF60
       .byte $66 ; | XX  XX | $FF61
       .byte $66 ; | XX  XX | $FF62
       .byte $66 ; | XX  XX | $FF63
       .byte $3C ; |  XXXX  | $FF64
       .byte $3C ; |  XXXX  | $FF65
       .byte $18 ; |   XX   | $FF66
       .byte $18 ; |   XX   | $FF67
       .byte $18 ; |   XX   | $FF68
       .byte $18 ; |   XX   | $FF69
       .byte $38 ; |  XXX   | $FF6A
       .byte $18 ; |   XX   | $FF6B
       .byte $7E ; | XXXXXX | $FF6C
       .byte $60 ; | XX     | $FF6D
       .byte $60 ; | XX     | $FF6E
       .byte $3C ; |  XXXX  | $FF6F
       .byte $06 ; |     XX | $FF70
       .byte $46 ; | X   XX | $FF71
       .byte $3C ; |  XXXX  | $FF72
       .byte $3C ; |  XXXX  | $FF73
       .byte $46 ; | X   XX | $FF74
       .byte $06 ; |     XX | $FF75
       .byte $0C ; |    XX  | $FF76
       .byte $06 ; |     XX | $FF77
       .byte $46 ; | X   XX | $FF78
       .byte $3C ; |  XXXX  | $FF79
       .byte $0C ; |    XX  | $FF7A
       .byte $0C ; |    XX  | $FF7B
       .byte $7E ; | XXXXXX | $FF7C
       .byte $4C ; | X  XX  | $FF7D
       .byte $2C ; |  X XX  | $FF7E
       .byte $1C ; |   XXX  | $FF7F
       .byte $0C ; |    XX  | $FF80
       .byte $7C ; | XXXXX  | $FF81
       .byte $46 ; | X   XX | $FF82
       .byte $06 ; |     XX | $FF83
       .byte $7C ; | XXXXX  | $FF84
       .byte $60 ; | XX     | $FF85
       .byte $60 ; | XX     | $FF86
       .byte $7E ; | XXXXXX | $FF87
       .byte $3C ; |  XXXX  | $FF88
       .byte $66 ; | XX  XX | $FF89
       .byte $66 ; | XX  XX | $FF8A
       .byte $7C ; | XXXXX  | $FF8B
       .byte $60 ; | XX     | $FF8C
       .byte $62 ; | XX   X | $FF8D
       .byte $3C ; |  XXXX  | $FF8E
       .byte $18 ; |   XX   | $FF8F
       .byte $18 ; |   XX   | $FF90
       .byte $18 ; |   XX   | $FF91
       .byte $0C ; |    XX  | $FF92
       .byte $06 ; |     XX | $FF93
       .byte $42 ; | X    X | $FF94
       .byte $7E ; | XXXXXX | $FF95
       .byte $3C ; |  XXXX  | $FF96
       .byte $66 ; | XX  XX | $FF97
       .byte $66 ; | XX  XX | $FF98
       .byte $3C ; |  XXXX  | $FF99
       .byte $66 ; | XX  XX | $FF9A
       .byte $66 ; | XX  XX | $FF9B
       .byte $3C ; |  XXXX  | $FF9C
       .byte $3C ; |  XXXX  | $FF9D
       .byte $46 ; | X   XX | $FF9E
       .byte $06 ; |     XX | $FF9F
       .byte $3E ; |  XXXXX | $FFA0
       .byte $66 ; | XX  XX | $FFA1
       .byte $66 ; | XX  XX | $FFA2
       .byte $3C ; |  XXXX  | $FFA3
       .byte $00 ; |        | $FFA4
       .byte $00 ; |        | $FFA5
       .byte $00 ; |        | $FFA6
       .byte $00 ; |        | $FFA7
       .byte $00 ; |        | $FFA8
       .byte $00 ; |        | $FFA9
       .byte $00 ; |        | $FFAA
       .byte $00 ; |        | $FFAB
       .byte $18 ; |   XX   | $FFAC
       .byte $00 ; |        | $FFAD
       .byte $00 ; |        | $FFAE
       .byte $00 ; |        | $FFAF
       .byte $18 ; |   XX   | $FFB0
       .byte $00 ; |        | $FFB1
       .byte $AD ; |X X XX X| $FFB2
       .byte $A9 ; |X X X  X| $FFB3
       .byte $E9 ; |XXX X  X| $FFB4
       .byte $A9 ; |X X X  X| $FFB5
       .byte $ED ; |XXX XX X| $FFB6
       .byte $41 ; | X     X| $FFB7
       .byte $0F ; |    XXXX| $FFB8
       .byte $50 ; | X X    | $FFB9
       .byte $58 ; | X XX   | $FFBA
       .byte $5C ; | X XXX  | $FFBB
       .byte $56 ; | X X XX | $FFBC
       .byte $53 ; | X X  XX| $FFBD
       .byte $11 ; |   X   X| $FFBE
       .byte $F0 ; |XXXX    | $FFBF
       .byte $BA ; |X XXX X | $FFC0
       .byte $8A ; |X   X X | $FFC1
       .byte $BA ; |X XXX X | $FFC2
       .byte $A2 ; |X X   X | $FFC3
       .byte $3A ; |  XXX X | $FFC4
       .byte $80 ; |X       | $FFC5
       .byte $FE ; |XXXXXXX | $FFC6
       .byte $E9 ; |XXX X  X| $FFC7
       .byte $AB ; |X X X XX| $FFC8
       .byte $AF ; |X X XXXX| $FFC9
       .byte $AD ; |X X XX X| $FFCA
       .byte $E9 ; |XXX X  X| $FFCB
       .byte $00 ; |        | $FFCC
       .byte $00 ; |        | $FFCD
LFFCE:
       .byte $48 ; | X  X   | $FFCE
       .byte $49 ; | X  X  X| $FFCF
       .byte $69 ; | XX X  X| $FFD0
       .byte $6A ; | XX X X | $FFD1
LFFD2:
       .byte $CD ; |XX  XX X| $FFD2
       .byte $48 ; | X  X   | $FFD3
       .byte $5B ; | X XX XX| $FFD4
       .byte $5B ; | X XX XX| $FFD5
       .byte $5B ; | X XX XX| $FFD6
       .byte $6E ; | XX XXX | $FFD7
       .byte $81 ; |X      X| $FFD8
       .byte $E0 ; |XXX     | $FFD9

LFFDA:
       .byte $CD ; |XX  XX X| $FFDA
LFFDB:
       .byte $FE ; |XXXXXXX | $FFDB
       .byte $A6 ; |X X  XX | $FFDC
       .byte $F1 ; |XXXX   X| $FFDD
       .byte $A6 ; |X X  XX | $FFDE
       .byte $F1 ; |XXXX   X| $FFDF
       .byte $B9 ; |X XXX  X| $FFE0
       .byte $F1 ; |XXXX   X| $FFE1
       .byte $4A ; | X  X X | $FFE2
       .byte $FF ; |XXXXXXXX| $FFE3
       .byte $4A ; | X  X X | $FFE4
       .byte $FF ; |XXXXXXXX| $FFE5
       .byte $B9 ; |X XXX  X| $FFE6
       .byte $F1 ; |XXXX   X| $FFE7
       .byte $A6 ; |X X  XX | $FFE8
       .byte $F1 ; |XXXX   X| $FFE9

LFFEA:
       .byte $CD ; |XX  XX X| $FFEA
LFFEB:
       .byte $FE ; |XXXXXXX | $FFEB
       .byte $BA ; |X XXX X | $FFEC
       .byte $FE ; |XXXXXXX | $FFED
       .byte $BA ; |X XXX X | $FFEE
       .byte $FE ; |XXXXXXX | $FFEF
       .byte $A7 ; |X X  XXX| $FFF0
       .byte $FE ; |XXXXXXX | $FFF1
       .byte $94 ; |X  X X  | $FFF2
       .byte $FE ; |XXXXXXX | $FFF3
       .byte $94 ; |X  X X  | $FFF4
       .byte $FE ; |XXXXXXX | $FFF5
       .byte $A7 ; |X X  XXX| $FFF6
       .byte $FE ; |XXXXXXX | $FFF7
       .byte $BA ; |X XXX X | $FFF8
       .byte $FE ; |XXXXXXX | $FFF9

LFFFA:
       .byte $02 ; |      X | $FFFA
       .byte $2B ; |  X X XX| $FFFB

       ORG $FFFC
       .word START,0
